﻿Public Class frmUpdate

#Region "Properties"

    Private _contactID As Integer
    Private _firstName
    Private _lastName
    Private _address
    Private _city
    Private _stateOrProv
    Private _postalCode
    Private _workPhone
    Private _homePhone
    Private _mobilePhone
    Private _emailName
    Private _birthDate
    Private _notes
    Private _contactTypeID

    Public Property [ContactID]() As Integer
        Get
            Return _contactID
        End Get
        Set(ByVal Value As Integer)
            _contactID = Value
        End Set
    End Property

    Public Property [FirstName]() As String
        Get
            Return _firstName
        End Get
        Set(ByVal Value As String)
            _firstName = Value
        End Set
    End Property

    Public Property [LastName]() As String
        Get
            Return _lastName
        End Get
        Set(ByVal Value As String)
            _lastName = Value
        End Set
    End Property

    Public Property [Address]() As String
        Get
            Return _address
        End Get
        Set(ByVal Value As String)
            _address = Value
        End Set
    End Property

    Public Property [City]() As String
        Get
            Return _city
        End Get
        Set(ByVal Value As String)
            _city = Value
        End Set
    End Property

    Public Property [StateOrProvince]() As String
        Get
            Return _stateOrProv
        End Get
        Set(ByVal Value As String)
            _stateOrProv = Value
        End Set
    End Property

    Public Property [PostalCode]() As String
        Get
            Return _postalCode
        End Get
        Set(ByVal Value As String)
            _postalCode = Value
        End Set
    End Property

    Public Property [WorkPhone]() As String
        Get
            Return _workPhone
        End Get
        Set(ByVal Value As String)
            _workPhone = Value
        End Set
    End Property

    Public Property [HomePhone]() As String
        Get
            Return _homePhone
        End Get
        Set(ByVal Value As String)
            _homePhone = Value
        End Set
    End Property

    Public Property [MobilePhone]() As String
        Get
            Return _mobilePhone
        End Get
        Set(ByVal Value As String)
            _mobilePhone = Value
        End Set
    End Property

    Public Property [EmailName]() As String
        Get
            Return _emailName
        End Get
        Set(ByVal Value As String)
            _emailName = Value
        End Set
    End Property

    Public Property [BirthDate]() As String
        Get
            Return _birthDate
        End Get
        Set(ByVal Value As String)
            _birthDate = Value
        End Set
    End Property

    Public Property [Notes]() As String
        Get
            Return _notes
        End Get
        Set(ByVal Value As String)
            _notes = Value
        End Set
    End Property

    Public Property [ContactTypeID]() As Integer
        Get
            Return _contactTypeID
        End Get
        Set(ByVal Value As Integer)
            _contactTypeID = Value - 1
        End Set
    End Property

#End Region

    Private Sub frmUpdate_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lblContactID.Text = _contactID
        'Dim ContactService As New BL.ContactService
        'ContactService.GetOneContact(_passedID)

        Dim ContactTypeService As New BL.ContactTypeService
        Dim ContactTypesList = ContactTypeService.GetContactTypes()
        Dim item As String

        For Each ct In ContactTypesList
            item = ct.ContactTypeID.ToString + " - " + ct.ContactType.ToString
            lstContactType.Items.Add(item)
        Next

        txtFirstName.Text = _firstName
        txtLastName.Text = _lastName
        txtAddress.Text = _address
        txtCity.Text = _city
        txtState.Text = _stateOrProv
        txtPostalCode.Text = _postalCode
        txtWorkPhone.Text = _workPhone
        txtHomePhone.Text = _homePhone
        txtMobilePhone.Text = _mobilePhone
        txtEmailName.Text = _emailName
        txtBirthDate.Text = _birthDate
        txtNotes.Text = _notes
        lstContactType.SelectedIndex = _contactTypeID

    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.Close()
    End Sub

    Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click
        _firstName = txtFirstName.Text
        _lastName = txtLastName.Text
        _address = txtAddress.Text
        _city = txtCity.Text
        _stateOrProv = txtState.Text
        _postalCode = txtPostalCode.Text
        _workPhone = txtWorkPhone.Text
        _homePhone = txtHomePhone.Text
        _mobilePhone = txtMobilePhone.Text
        _emailName = txtEmailName.Text
        _birthDate = txtBirthDate.Text
        _contactTypeID = Mid(lstContactType.SelectedItem, 1, 1)
        _notes = txtNotes.Text

        Dim ContactService As New BL.ContactService
        ContactService.UpdateContact(_contactID, _firstName, _lastName, _address, _city, _stateOrProv, _postalCode, _workPhone, _homePhone, _mobilePhone, _emailName, _birthDate, _contactTypeID, _notes)
        Me.Close()

    End Sub
End Class