﻿Option Strict On
Option Explicit On

Public Class frmContacts

    Private Sub frmContacts_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        BindGrid()
    End Sub

    Private Sub BindGrid()
        Dim ContactService As New BL.ContactService
        grdContacts.DataSource = ContactService.GetContacts()
    End Sub

    Private Sub grdContacts_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles grdContacts.CellContentClick
        If e.ColumnIndex < 2 Then 'make sure they clicked one of the buttons
            Dim contactService As New BL.ContactService()
            Dim id As Integer = CInt(grdContacts.Item(2, e.RowIndex).Value)
            Dim selectedId As Integer = CInt(grdContacts(2, e.RowIndex).Value)
            If e.ColumnIndex = 0 Then
                'Delete
                contactService.DeleteContact(selectedId)
            Else
                'Update
                Dim frm As New frmUpdate
                'open new Update Form and pass it the selectedID
                frm.ContactID = selectedId
                frm.FirstName = grdContacts(3, e.RowIndex).Value.ToString
                frm.LastName = grdContacts(4, e.RowIndex).Value.ToString
                frm.Address = grdContacts(5, e.RowIndex).Value.ToString
                frm.City = grdContacts(6, e.RowIndex).Value.ToString
                frm.StateOrProvince = grdContacts(7, e.RowIndex).Value.ToString
                frm.PostalCode = grdContacts(8, e.RowIndex).Value.ToString
                frm.WorkPhone = grdContacts(9, e.RowIndex).Value.ToString
                frm.HomePhone = grdContacts(10, e.RowIndex).Value.ToString
                frm.MobilePhone = grdContacts(11, e.RowIndex).Value.ToString
                frm.EmailName = grdContacts(12, e.RowIndex).Value.ToString
                frm.BirthDate = grdContacts(13, e.RowIndex).Value.ToString
                frm.ContactTypeID = CInt(grdContacts(15, e.RowIndex).Value)
                frm.Notes = grdContacts(16, e.RowIndex).Value.ToString
                frm.ShowDialog()
            End If
            BindGrid()
        End If
    End Sub

    Private Sub grdContacts_DataBindingComplete(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewBindingCompleteEventArgs) Handles grdContacts.DataBindingComplete
        'Hide the Columns we do not want to display (there are still there and we can code against them they are just invisible)
        grdContacts.Columns(2).Visible = False
        grdContacts.Columns(15).Visible = False
    End Sub

End Class
